package de.communardo.confluence.plugins.displaysubspace;

import java.util.Map;

import com.atlassian.confluence.renderer.radeox.macros.MacroUtils;
import com.atlassian.confluence.security.SpacePermission;
import com.atlassian.confluence.security.SpacePermissionManager;
import com.atlassian.confluence.themes.GlobalHelper;
import com.atlassian.confluence.user.AuthenticatedUserThreadLocal;
import com.atlassian.plugin.PluginParseException;
import com.atlassian.plugin.web.ContextProvider;

public class DashboardMacroContextProvider implements ContextProvider{

	private SpacePermissionManager spacePermissionManager;
	
	public Map<String, Object> getContextMap(Map<String, Object> map) {
		
		map.putAll(MacroUtils.defaultVelocityContext());
		map.put("helper", new GlobalHelper());
		map.put("canAddSpaces", spacePermissionManager.hasPermission(SpacePermission.CREATE_SPACE_PERMISSION, null, AuthenticatedUserThreadLocal.getUser()));
		
		return map;
	}

	public void init(Map<String, String> arg0) throws PluginParseException {
	}

	
	public void setSpacePermissionManager(SpacePermissionManager spacePermissionManager) {
		this.spacePermissionManager = spacePermissionManager;
	}

}
