package de.communardo.confluence.plugins.quicksearch;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import de.communardo.confluence.plugins.displaysubspace.TreeNode;

public class QuickSearchUtil {

    /**
     * recusivly parse the tree and return the spacekeys as collection
     * 
     * @param treeNode
     * @return
     */
    public static Collection<String> getSpacesFromTreeNode(TreeNode treeNode) {
        Set<String> resultSet = new HashSet<String>();
        if (treeNode != null) {
            resultSet.add(treeNode.getSpace().getKey());
            for (TreeNode currNode : treeNode.getChildren()) {
                resultSet.addAll(getSpacesFromTreeNode(currNode));
            }
        }
        return resultSet;
    }
}
