package de.communardo.confluence.plugins.util;

import com.atlassian.bandana.BandanaManager;
import com.atlassian.confluence.labels.LabelManager;
import com.atlassian.confluence.security.PermissionManager;
import com.atlassian.confluence.spaces.SpaceManager;
import com.atlassian.spring.container.ContainerManager;

/**
 * 
 * @author Bill Martin
 * 
 */
public class ComponentManager {

	private static ComponentManager INSTANCE = null;
	private BandanaManager bandanaManager;
	private SpaceManager spaceManager;
	private LabelManager labelManager;
	private PermissionManager permissionManager;

	/**
	 * Hidden constructor
	 */
	private ComponentManager() {

	}

	/**
	 * Returns the single instance.
	 * 
	 * @return the single instance
	 */
	private static ComponentManager getInstance() {
		if (INSTANCE == null) {
			INSTANCE = new ComponentManager();
			// works only for Confluence core components, add your own
			// components manually
			ContainerManager.autowireComponent(INSTANCE);
		}
		return INSTANCE;
	}

	/**
	 * 
	 * @param bm
	 *            Bandana manager (autoinjected by Spring)
	 */
	public void setBandanaManager(BandanaManager bm) {
		this.bandanaManager = bm;
	}

	/**
	 * 
	 * @return the Bandana manager
	 */
	public static BandanaManager getBandanaManager() {
		return getInstance().bandanaManager;
	}

	/**
	 * 
	 * @param sm
	 *            Space manager (autoinjected by Spring)
	 */
	public void setSpaceManager(SpaceManager sm) {
		this.spaceManager = sm;
	}

	/**
	 * 
	 * @return the Space manager
	 */
	public static SpaceManager getSpaceManager() {
		return getInstance().spaceManager;
	}

	/**
	 * 
	 * @return the Label manager
	 */
	public static LabelManager getLabelManager() {
		return getInstance().labelManager;
	}

	/**
	 * 
	 * @param lm
	 *            Space manager (autoinjected by Spring)
	 */
	public void setLabelManager(LabelManager lm) {
		this.labelManager = lm;
	}
	
	/**
	 * 
	 * @return the Permission Manager
	 */
	public static PermissionManager getPermissionManager() {
		return getInstance().permissionManager;
	}

	/**
	 * 
	 * @param pm
	 */
	public void setPermissionManager(PermissionManager pm) {
		this.permissionManager = pm;
	}
}
